Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_basic.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_basic.pro	(revision 76)
+++ 	(revision )
@@ -1,28 +1,0 @@
-PRO tst_basic
-;
-; figure 1: basics plots
-;
-; 1) plot
-;
-  n = 10
-  y = findgen(n)
-; basic plot
-  splot, y, small = [2, 2, 1], /portrait
-; improved plot by using plot and "graphic keywords"
-  splot, y, small = [2, 2, 2], /noerase, yrange = [0, (n-1)^2], title = 'x and x^2'
-  oplot, y^2, color = 100, linestyle = 2, thick = 3
-;
-; 2) contour
-;
-  z = dist(n)
-; basic plot
-  scontour, z, /fill, nlevels = 15, small = [2, 2, 3], /noerase
-; improved plot by using contour and "graphic keywords"
-  ind = findgen(2*n)/(2.*n)
-  scontour, z, levels = n*ind, c_orientation = 180*ind, c_spacing = .2*ind $
-            , small = [2, 2, 4], /noerase
-  contour, z, /overplot, c_label = rebin([1, 0], 2, n), levels = n*ind $
-           , c_charthick = 2, c_charsize = 1.5, c_colors = 250*ind
-           
-  return
-end
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev.pro	(revision 76)
+++ 	(revision )
@@ -1,4 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-initncdf, file, glamboundary = [20, 380], useasmask = 'votemper' $
-          , missing_value = 31.0720, iodirectory = [iodir, homedir, !path] $
-          , /recursive
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev_index.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev_index.pro	(revision 76)
+++ 	(revision )
@@ -1,4 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-initncdf, file, glamboundary = [20, 380], useasmask = 'votemper' $
-          , missing_value = 31.0720, iodirectory = [iodir, homedir, !path] $
-          , /recursive, /xyindex
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev_index_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev_index_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,4 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-initncdf, file, glamboundary = [20, 380], useasmask = 'votemper' $
-          , missing_value = 31.0720, iodirectory = [iodir, homedir, !path] $
-          , /recursive, /xyindex, stride = [2, 2, 1]
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initlev_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,4 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-initncdf, file, glamboundary = [20, 380], useasmask = 'votemper' $
-          , missing_value = 31.0720, iodirectory = [iodir, homedir, !path] $
-          , /recursive, stride = [2, 2, 1]
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05.pro	(revision 76)
+++ 	(revision )
@@ -1,42 +1,0 @@
-;
-@cm_4mesh
-@cm_4cal
-@cm_4data
-;----------------------------------------------------------
-; boundaries of the read grid regarding to the original grid
-;----------------------------------------------------------
-ixminmesh  =1
-ixmaxmesh  =720
-;
-iyminmesh  =0
-iymaxmesh  =509
-;
-izminmesh  =-1
-izmaxmesh  =-1
-;
-jpt=1
-time = 0
-;------------------------------------------------------
-;  read the grid
-;------------------------------------------------------
-key_stride = [1, 1, 1]
-ncdf_meshread, 'micromeshmaskORCA05.nc', glamboundary = [20, 380] $
-              , iodirectory = [iodir, homedir, !path], /recursive
-;-------------------------------------------------------------
-domdef
-;
-triangles_list = triangule(/keep_cont)
-;----------------------------------------------------------
-; boundaries of the data regarding to the original grid
-;----------------------------------------------------------
-jpidta = jpiglo
-jpjdta = jpjglo
-jpkdta = jpkglo
-ixmindta = 0
-ixmaxdta = jpidta-1
-iymindta = 0
-iymaxdta = jpjdta-1
-izmindta = 0
-izmaxdta = jpkdta-1
-;----------------------------------------------------------
-@updateold
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_index.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_index.pro	(revision 76)
+++ 	(revision )
@@ -1,32 +1,0 @@
-;
-; definition of the domain on ORCA2 but with i/j index instead of
-; longitude/latitude
-;
-; deferent possibilities are proposed
-;
-; 1) definition with a file
-;
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-initncdf, file, xminmesh = 1, xmaxmesh = -1 $
-          , yminmesh = 0, ymaxmesh = -1, /xyindex $
-          , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 2) definition with the meshmask
-;
-; file = 'micromeshmaskORCA05.nc'
-; initncdf, file, xaxisname = 'glamt', yaxisname = 'gphit' $
-;           , /xyindex, zaxisname = 'gdept' $
-;           , yminmesh = 0, ymaxmesh = -1, xminmesh = 1, xmaxmesh = -1 $
-;           , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 3) by calling directly computegrid
-;
-; if we don't know jpiglo and jpjglo, we call ncdf_meshread with /getdimensions
-; ncdf_meshread, 'micromeshmaskORCA05.nc', /getdimensions $
-;               , iodirectory = [iodir, homedir, !path], /recursive
-;---------------------------------------------------------
-; define the grid parameters
-;---------------------------------------------------------
-; computegrid, 0, 0, 1, 1, jpiglo, jpjglo, xminmesh = 1, xmaxmesh = -1 $
-;              , yminmesh = 0, ymaxmesh = -1, onearth = 0 $
-;              , iodirectory = [iodir, homedir, !path], /recursive
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_index_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_index_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,32 +1,0 @@
-;
-; definition of the domain on ORCA2 but with i/j index instead of
-; longitude/latitude
-;
-; deferent possibilities are proposed
-;
-; 1) definition with a file
-;
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-initncdf, file, xminmesh = 1, xmaxmesh = -1 $
-          , yminmesh = 0, ymaxmesh = -1, /xyindex, stride = [2, 1, 1] $
-          , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 2) definition with the meshmask
-;
-; file = 'micromeshmaskORCA05.nc'
-; initncdf, file, xaxisname = 'glamt', yaxisname = 'gphit' $
-;           , /xyindex, zaxisname = 'gdept', stride = [2, 1, 1] $
-;           , yminmesh = 0, ymaxmesh = -1, xminmesh = 1, xmaxmesh = -1 $
-;           , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 3) by calling directly computegrid
-;
-; if we don't know jpiglo and jpjglo, we call ncdf_meshread with /getdimensions
-; ncdf_meshread, 'micromeshmaskORCA05.nc', /getdimensions $
-;               , iodirectory = [iodir, homedir, !path], /recursive
-;---------------------------------------------------------
-; define the grid parameters
-;---------------------------------------------------------
-; computegrid, 0, 0, 1, 1, jpiglo, jpjglo, xminmesh = 1, xmaxmesh = -1 $
-;           , yminmesh = 0, ymaxmesh = -1, onearth = 0, stride = [2, 1, 1] $
-;           , iodirectory = [iodir, homedir, !path], /recursive
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_short.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_short.pro	(revision 76)
+++ 	(revision )
@@ -1,4 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-initncdf, file, glamboundary = [20, 380], xminmesh = 1, xmaxmesh = -1 $
-          , yminmesh = 0, ymaxmesh = -1, iodirectory = [iodir, homedir, !path] $
-          , /recursive
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_short_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_short_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,4 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-initncdf, file, glamboundary = [20, 380], xminmesh = 1, xmaxmesh = -1 $
-          , yminmesh = 0, ymaxmesh = -1, iodirectory = [iodir, homedir, !path] $
-          , /recursive, stride = [2, 2, 1]
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca05_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,42 +1,0 @@
-;
-@cm_4mesh
-@cm_4cal
-@cm_4data
-;----------------------------------------------------------
-; boundaries of the read grid regarding to the original grid
-;----------------------------------------------------------
-ixminmesh  =1
-ixmaxmesh  =720
-;
-iyminmesh  =0
-iymaxmesh  =509
-;
-izminmesh  =-1
-izmaxmesh  =-1
-;
-jpt=1
-time = 0
-;------------------------------------------------------
-;  read the grid
-;------------------------------------------------------
-key_stride = [2, 2, 1]
-ncdf_meshread, 'micromeshmaskORCA05.nc', glamboundary = [20, 380] $
-              , iodirectory = [iodir, homedir, !path], /recursive
-;-------------------------------------------------------------
-domdef
-;
-triangles_list = triangule(/keep_cont)
-;----------------------------------------------------------
-; boundaries of the data regarding to the original grid
-;----------------------------------------------------------
-jpidta = jpiglo
-jpjdta = jpjglo
-jpkdta = jpkglo
-ixmindta = 0
-ixmaxdta = jpidta-1
-iymindta = 0
-iymaxdta = jpjdta-1
-izmindta = 0
-izmaxdta = jpkdta-1
-;----------------------------------------------------------
-@updateold
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2.pro	(revision 76)
+++ 	(revision )
@@ -1,42 +1,0 @@
-;
-@cm_4mesh
-@cm_4cal
-@cm_4data
-;---------------------------------------------------------
-; boundaries of the read grid regarding to the original grid
-;----------------------------------------------------------
-ixminmesh  =1
-ixmaxmesh  =180
-;
-iyminmesh  =0
-iymaxmesh  =147
-;
-izminmesh  =-1
-izmaxmesh  =-1
-;
-jpt = 1
-time = 0
-;------------------------------------------------------
-; read the grid
-;------------------------------------------------------
-key_stride = [1, 1, 1]
-ncdf_meshread, 'micromeshmaskORCA2.nc', glamboundary = [20, 380] $
-              , iodirectory = [iodir, homedir, !path], /recursive
-;-------------------------------------------------------------
-domdef
-;
-triangles_list = triangule()
-;----------------------------------------------------------
-; boundaries of the data regarding to the original grid
-;----------------------------------------------------------
-jpidta = jpiglo
-jpjdta = jpjglo
-jpkdta = jpkglo
-ixmindta = 0
-ixmaxdta = jpidta-1
-iymindta = 0
-iymaxdta = jpjdta-1
-izmindta = 0
-izmaxdta = jpkdta-1
-;----------------------------------------------------------
-@updateold
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_index.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_index.pro	(revision 76)
+++ 	(revision )
@@ -1,33 +1,0 @@
-;
-; definition of the domain on ORCA2 but with i/j index instead of
-; longitude/latitude
-;
-; deferent possibilities are proposed
-;
-;
-; 1) definition with a file
-;
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-initncdf, file, xminmesh = 1, xmaxmesh = -1 $
-          , yminmesh = 0, ymaxmesh = -1, /xyindex $
-          , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 2) definition with the meshmask
-;
-; file = 'micromeshmaskORCA2.nc'
-; initncdf, file, xaxisname = 'glamt', yaxisname = 'gphit' $
-;           , /xyindex, zaxisname = 'gdept' $
-;           , yminmesh = 0, ymaxmesh = -1, xminmesh = 1, xmaxmesh = -1 $
-;           , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 3) by calling directly computegrid
-;
-; if we don't know jpiglo and jpjglo, we call ncdf_meshread with /getdimensions
-; ncdf_meshread, 'micromeshmaskORCA2.nc', /getdimensions $
-;               , iodirectory = [iodir, homedir, !path], /recursive
-;---------------------------------------------------------
-; define the grid parameters
-;---------------------------------------------------------
-; computegrid, 0, 0, 1, 1, jpiglo, jpjglo, xminmesh = 1, xmaxmesh = -1 $
-;              , yminmesh = 0, ymaxmesh = -1, onearth = 0 $
-;              , iodirectory = [iodir, homedir, !path], /recursive
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_index_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_index_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,33 +1,0 @@
-;
-; definition of the domain on ORCA2 but with i/j index instead of
-; longitude/latitude
-;
-; deferent possibilities are proposed
-;
-;
-; 1) definition with a file
-;
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-initncdf, file, xminmesh = 1, xmaxmesh = -1 $
-          , yminmesh = 0, ymaxmesh = -1, /xyindex, stride = [2, 2, 1] $
-          , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 2) definition with the meshmask
-;
-; file = 'micromeshmaskORCA2.nc'
-; initncdf, file, xaxisname = 'glamt', yaxisname = 'gphit' $
-;           , /xyindex, zaxisname = 'gdept', stride = [2, 2, 1] $
-;           , yminmesh = 0, ymaxmesh = -1, xminmesh = 1, xmaxmesh = -1 $
-;           , iodirectory = [iodir, homedir, !path], /recursive
-;
-; 3) by calling directly computegrid
-;
-; if we don't know jpiglo and jpjglo, we call ncdf_meshread with /getdimensions
-; ncdf_meshread, 'micromeshmaskORCA2.nc', /getdimensions $
-;               , iodirectory = [iodir, homedir, !path], /recursive
-;---------------------------------------------------------
-; define the grid parameters
-;---------------------------------------------------------
-; computegrid, 0, 0, 1, 1, jpiglo, jpjglo, xminmesh = 1, xmaxmesh = -1 $
-;           , yminmesh = 0, ymaxmesh = -1, onearth = 0, stride = [2, 2, 1] $
-;           , iodirectory = [iodir, homedir, !path], /recursive
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_short.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_short.pro	(revision 76)
+++ 	(revision )
@@ -1,5 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-initncdf, file, glamboundary = [20, 380], xminmesh = 1, xmaxmesh = 180 $
-          , yminmesh = 0, ymaxmesh = 147, iodirectory = [iodir, homedir, !path] $
-          , /recursive
-
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_short_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_short_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,5 +1,0 @@
-file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-initncdf, file, glamboundary = [20, 380], xminmesh = 1, xmaxmesh = 180 $
-          , yminmesh = 0, ymaxmesh = 147, iodirectory = [iodir, homedir, !path] $
-          , /recursive, stride = [2, 2, 1]
-
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_stride.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_initorca2_stride.pro	(revision 76)
+++ 	(revision )
@@ -1,42 +1,0 @@
-;
-@cm_4mesh
-@cm_4cal
-@cm_4data
-;---------------------------------------------------------
-; boundaries of the read grid regarding to the original grid
-;----------------------------------------------------------
-ixminmesh  =1
-ixmaxmesh  =180
-;
-iyminmesh  =0
-iymaxmesh  =147
-;
-izminmesh  =-1
-izmaxmesh  =-1
-;
-jpt = 1
-time = 0
-;------------------------------------------------------
-; read the grid
-;------------------------------------------------------
-key_stride = [2, 2, 1]
-ncdf_meshread, 'micromeshmaskORCA2.nc', glamboundary = [20, 380] $
-              , iodirectory = [iodir, homedir, !path], /recursive
-;-------------------------------------------------------------
-domdef
-;
-triangles_list = triangule()
-;----------------------------------------------------------
-; boundaries of the data regarding to the original grid
-;----------------------------------------------------------
-jpidta = jpiglo
-jpjdta = jpjglo
-jpkdta = jpkglo
-ixmindta = 0
-ixmaxdta = jpidta-1
-iymindta = 0
-iymaxdta = jpjdta-1
-izmindta = 0
-izmaxdta = jpkdta-1
-;----------------------------------------------------------
-@updateold
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_plt.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_plt.pro	(revision 76)
+++ 	(revision )
@@ -1,85 +1,0 @@
-PRO tst_plt, IMAGE = image
-; commons
-@cm_4mesh
-;
-; figure 2: regular grid
-;
-  CASE jpi*key_stride[0]+jpj*key_stride[1] OF
-    180+148:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-    360+180:file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-    720+510:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-  ENDCASE
-  file = isafile(file, iodirectory = [iodir, homedir, !path] $
-                 , title = 'Where is '+file+' ?', /recursive)
-  IF size(file, /type) NE 7 THEN return
-;
-  dummy = ''
-  cnt = 1
-;
-  domdef
-  domdef, gdept[0], gdept[0], gridtype = 'T'
-  temp = read_ncdf('votemper', 10101, 10131, file = file)
-;
-  plt, temp, /landscape
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  plt, temp, -2, 31, int = .5, /nocontour, format = '(i3)'
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  plt, temp, -2, 31, int = 1, /color_c
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  plt, temp, -2, 31, int = 1, /nofill, c_thick = 1, coast_thick = 2
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  plt, temp, cell_fill = 1 + (jpi EQ 180) ; we must use cell_fill = 2 for ORCA2
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-; zoom
-  IF key_onearth THEN box = [40, 375, -20, 20] $
-  ELSE box = [jpi/4, 3*jpi/4, jpj/4, 3*jpj/4] 
-  plt, temp, boxzoom = box, /landscape
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-
-; projections
-  IF key_onearth THEN BEGIN
-; 
-    plt, temp, boxzoom = [20, 380, 60, 90], /stereo, map = [90, 0, 0], /portrait
-    if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-    ELSE read, dummy,  prompt = 'press return for the next plot'
-    cnt = cnt + 1
-;
-    plt, temp, boxzoom = [20, 380, -90, 50], /ortho, map = [-90, 180, 0], /portrait
-    if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-    ELSE read, dummy,  prompt = 'press return for the next plot'
-    cnt = cnt + 1
-;
-    plt, temp, /ortho, map = [0, 0, 21], /portrait, /realcont
-    if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
-    ELSE read, dummy,  prompt = 'press return for the next plot'
-    cnt = cnt + 1
-;
-  ENDIF
-
-; deep plot
-; domdef, 150, 150 ; => warning message
-  domdef, gdept[jpk/2], gdept[jpk/2], gridtype = 'T'
-  temp = read_ncdf('votemper', 10101, 10131, file = file)
-  plt, temp, realcont = 2*(key_onearth), /land
-  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png
-  cnt = cnt + 1
-
-
-  return
-end
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_pltt.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_pltt.pro	(revision 76)
+++ 	(revision )
@@ -1,84 +1,0 @@
-PRO tst_pltt, IMAGE = image
-; commons
-@cm_4mesh
-@cm_4cal
-;
-; figure 2: regular grid
-;
-  CASE jpi*key_stride[0]+jpj*key_stride[1] OF
-    180+148:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-    360+180:file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-    720+510:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-  ENDCASE
-  file = isafile(file, iodirectory = [iodir, homedir, !path] $
-                 , title = 'Where is '+file+' ?', /recursive)
-  IF size(file, /type) NE 7 THEN return
-;
-  dummy = ''
-  cnt = 1
-;
-; -1/1 xt plot
-;
-  IF key_onearth THEN domdef, 20, 380, -1, 1, 0, gdept[0] $
-  ELSE domdef, min(glamt), max(glamf), jpj/2-1, jpj/2+1, 0, gdept[0]
-;
-  temp = read_ncdf('votemper', 10101, 11231, file = file)
-  IF key_forgetold THEN help, temp.arr ELSE help, temp.tab
-  help, jpt, time
-  pltt, temp
-  if keyword_set(image) then saveimage, 'tst_pltt_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltt, temp, /nocontour
-  if keyword_set(image) then saveimage, 'tst_pltt_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltt, temp, /color_c
-  if keyword_set(image) then saveimage, 'tst_pltt_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltt, temp, /nofill
-  if keyword_set(image) then saveimage, 'tst_pltt_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-; equatorial plot
-;
-  IF key_onearth THEN BEGIN 
-    a = abs(gphit[0, *])
-    yind = where(a EQ min(a))
-    domdef, 20, 380, yind[0], yind[n_elements(yind)-1] $
-      , gdept[10 < (jpk-1)], gdept[10 < (jpk-1)], gridtype = 'T', /yindex
-  ENDIF ELSE BEGIN 
-    domdef, min(glamt), max(glamf), jpj/2, jpj/2 $
-      , gdept[10 < (jpk-1)], gdept[10 < (jpk-1)], gridtype = 'T', /yindex
-  ENDELSE 
-  temp = read_ncdf('votemper', 10101, 11231, file = file)
-  IF key_forgetold THEN help, temp.arr ELSE help, temp.tab
-  pltt, temp
-  if keyword_set(image) then saveimage, 'tst_pltt_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-; yt plot along the column that contain the largest latitude
-;
-  IF key_onearth THEN BEGIN 
-    ind = where(gphit EQ max(gphit))
-    ind = ind[0] MOD jpi
-    domdef, ind, ind, -90, 90, gdept[0], gdept[0], gridtype = 'T', /xindex
-  ENDIF ELSE BEGIN 
-    domdef, jpi/2, jpi/2, min(gphit), max(gphif), gdept[0], gdept[0], gridtype = 'T', /xindex
-  ENDELSE 
-
-  temp = read_ncdf('votemper', 10101, 11231, file = file)
-  IF key_forgetold THEN help, temp.arr ELSE help, temp.tab
-  pltt, temp
-
-  if keyword_set(image) then saveimage, 'tst_pltt_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png
-  cnt = cnt + 1
-
-  return
-end
Index: trunk/SRC/Documentation/xmldoc/idlfiles/tst_pltz.pro
===================================================================
--- trunk/SRC/Documentation/xmldoc/idlfiles/tst_pltz.pro	(revision 76)
+++ 	(revision )
@@ -1,127 +1,0 @@
-PRO tst_pltz, IMAGE = image
-; commons
-@cm_4mesh
-;
-  IF jpk EQ 1 THEN return
-;
-  dummy = ''
-  cnt = 1
-;
-  CASE jpi*key_stride[0]+jpj*key_stride[1] OF
-    180+148:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
-    360+180:file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
-    720+510:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
-  ENDCASE
-  file = isafile(file, iodirectory = [iodir, homedir, !path] $
-                 , title = 'Where is '+file+' ?', /recursive)
-  IF size(file, /type) NE 7 THEN return
-;
-  IF key_onearth THEN domdef, 20, 380, -1, 1, 0, max(gdept) $
-  ELSE domdef, min(glamt), max(glamf), jpj/2-1, jpj/2+1, 0, max(gdept)
-;
-  temp = read_ncdf('votemper', 10101, 10131, file = file)
-  IF key_forgetold THEN help, temp.arr ELSE help, temp.tab
-; 
-  pltz, temp, /portrait
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltz, temp, /portrait, /nocontour
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltz, temp, /portrait, /color_c
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltz, temp, /portrait, /nofill
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltz, temp, boxzoom = [6000]
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-                                ;
-  pltz, temp, boxzoom = [6000], zoom = 1000
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltz, temp, boxzoom = [6000], zoom = 1000, yxaspect = 2
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-  pltz, temp, boxzoom = [6000], zoom = 1000, yxaspect = 2, zratio = .5
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-; yt plot along the column that contain the largest latitude
-;
-  IF key_onearth THEN BEGIN 
-    ind = where(gphit EQ max(gphit))
-    ind = ind[0] MOD jpi
-    domdef, ind, ind, -90, 90, 0, max(gdept), gridtype = 'T', /xindex
-  ENDIF ELSE BEGIN 
-    domdef, jpi/2, jpi/2, min(gphit), max(gphif), 0, max(gdept), gridtype = 'T', /xindex
-  ENDELSE 
-
-  temp = read_ncdf('votemper', 10101, 11231, file = file)
-  pltz, temp, boxzoom = [6000], zoom = 1000, yxaspect = 2, zratio = .5
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-; oblique sections...
-;
-  IF key_onearth THEN endpoints = [110, -45, 290, 45] $
-  ELSE endpoints = [jpi/6, jpj/3, 5*jpi/6, 2*jpj/3]
-  domdef, endpoints = endpoints, type = 'pltz'
-  temp = read_ncdf('votemper', 10101, 10131, file = file)
-  pltz, temp, endpoints = endpoints
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-; false oblique sections...
-;
-  IF key_onearth THEN endpoints = [180, -70, 180, 90] $
-  ELSE endpoints = [jpi/2+0.25, +0.25, jpi/2+0.25,  jpj]
-  domdef, 6000, endpoints = endpoints, type = 'pltz'
-  temp = read_ncdf('votemper', 10101, 10131, file = file)
-  pltz, temp, endpoints = endpoints, boxzoom = [6000] $
-        , zoom = 1000, yxaspect = 2, zratio = .5 ; , /showbuild
-  if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png $
-  ELSE read, dummy,  prompt = 'press return for the next plot'
-  cnt = cnt + 1
-;
-; comparison between real section and false oblique sections
-;
-  IF (where(gphit EQ 0))[0] NE -1 THEN BEGIN 
-    IF key_onearth THEN box = [20, 380, 0, 0, 0, 6000] $
-    ELSE box = [0, jpi-1, jpj/2, jpj/2, 0, 6000]
-    domdef, box, gridtype = 'T'
-    temp = read_ncdf('votemper', 10101, 10131, file = file)
-    pltz, temp, boxzoom = [6000], /portrait, small = [1, 2, 1] $
-          , zoom = 500, zratio = .5
-    
-    IF key_onearth THEN endpoints = [20, 0, 380, 0] $
-    ELSE endpoints = [0, jpj/2, jpi-1, jpj/2]
-    domdef, 6000, endpoints = endpoints, type = 'pltz', gridtype = 'T'
-    temp = read_ncdf('votemper', 10101, 10131, file = file)
-    pltz, temp, endpoints = endpoints, boxzoom = [6000] $
-          , zoom = 500, zratio = .5 $
-          , small = [1, 2, 2], /noerase
-    
-    if keyword_set(image) then saveimage, 'tst_pltz_'+image+'_'+string(cnt, format = '(i2.2)')+'.png', /png
-    cnt = cnt + 1
-  ENDIF 
-  
-  return
-end