Index: trunk/SRC/Documentation/xmldoc/firststeps.xml
===================================================================
--- trunk/SRC/Documentation/xmldoc/firststeps.xml	(revision 79)
+++ trunk/SRC/Documentation/xmldoc/firststeps.xml	(revision 80)
@@ -4,7 +4,7 @@
 [
 <!ENTITY promptidl "idl&gt;">
-<!ENTITY numb1 '<inlinemediaobject><imageobject><imagedata fileref="images/callouts/1.png" format="PNG"/></imageobject><textobject><phrase>1</phrase></textobject></inlinemediaobject>'>
-<!ENTITY numb2 '<inlinemediaobject><imageobject><imagedata fileref="images/callouts/2.png" format="PNG"/></imageobject><textobject><phrase>2</phrase></textobject></inlinemediaobject>'>
-<!ENTITY showfig '<inlinemediaobject><imageobject><imagedata fileref="images/showfig.png" format="PNG"/></imageobject><textobject><phrase>show result</phrase></textobject></inlinemediaobject>'>
+<!ENTITY numb1 '<inlinemediaobject><imageobject><imagedata fileref="images/callouts/1.png?format=raw" format="PNG"/></imageobject><textobject><phrase>1</phrase></textobject></inlinemediaobject>'>
+<!ENTITY numb2 '<inlinemediaobject><imageobject><imagedata fileref="images/callouts/2.png?format=raw" format="PNG"/></imageobject><textobject><phrase>2</phrase></textobject></inlinemediaobject>'>
+<!ENTITY showfig '<inlinemediaobject><imageobject><imagedata fileref="images/showfig.png?format=raw" format="PNG"/></imageobject><textobject><phrase>show result</phrase></textobject></inlinemediaobject>'>
 ]>
 
@@ -131,5 +131,5 @@
    <prompt>&promptidl;</prompt> <userinput><command>n = 10</command></userinput>
    <prompt>&promptidl;</prompt> <userinput><command>y = findgen(n)</command></userinput> &numb1;
-   <prompt>&promptidl;</prompt> <userinput><command>plot, y</command></userinput> <ulink url="figpng/basic_plot.png">&showfig;</ulink>
+   <prompt>&promptidl;</prompt> <userinput><command>plot, y</command></userinput> <ulink url="figpng/basic_plot.png?format=raw">&showfig;</ulink>
 	</screen>
  	  <calloutlist>
@@ -150,5 +150,5 @@
 	Using IDL <command>plot</command> command is quite unconvenient to save the figure as a postscript. In addition, positionning the figure on the window/page by using <varname>!p.position</varname>, <varname>!p.region</varname> and <varname>!p.multi</varname> is often a nightmare. That's why we developped <command>splot</command> (like super-plot) which can be used in the same way as plot but is much more convenient to make postcript and position the figure.
 	<screen format="linespecific">
-  <prompt>&promptidl;</prompt> <userinput><command>splot, y</command></userinput> <ulink url="figpng/basic_splot1.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>splot, y</command></userinput> <ulink url="figpng/basic_splot1.png?format=raw">&showfig;</ulink>
   <computeroutput>% Compiled module: SPLOT.</computeroutput>
   <computeroutput>% Compiled module: REINITPLT.</computeroutput>
@@ -226,10 +226,10 @@
       <para>
 	<screen format="linespecific">
-  <prompt>&promptidl;</prompt> <userinput><command>splot, y, y^2, linestyle = 2, thick = 2, title = 'y = x^2', /portrait</command></userinput> <ulink url="figpng/basic_splot2.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>splot, y, y^2, linestyle = 2, thick = 2, title = 'y = x^2', /portrait</command></userinput> <ulink url="figpng/basic_splot2.png?format=raw">&showfig;</ulink>
 	</screen>
 	<command>splot</command> can be used to setup the graphic environment (<varname>!p</varname>, <varname>!x</varname>, <varname>!y</varname>, <varname>!z</varname> variables) needed by procedures like <command>oplot</command>
 	<screen format="linespecific">
   <prompt>&promptidl;</prompt> <userinput><command>splot, y, yrange = [0, (n-1)^2], title = 'x and x^2'</command></userinput>
-  <prompt>&promptidl;</prompt> <userinput><command>oplot, y^2, color = 50, linestyle = 2</command></userinput> <ulink url="figpng/basic_splot4.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>oplot, y^2, color = 50, linestyle = 2</command></userinput> <ulink url="figpng/basic_splot4.png?format=raw">&showfig;</ulink>
 	</screen>
 	Use the keyword small to produce multi plots figures. 
@@ -245,5 +245,5 @@
   <prompt>&promptidl;</prompt> <userinput><command>splot, y, y^2, title = 'y = x^2', psym = 2, small &numb1; = [1, 2, 1]</command></userinput>
   <prompt>&promptidl;</prompt> <userinput><command>splot, findgen(360)/36., findgen(360)*2.*!dtor, /polar $</command></userinput>
-  <prompt>&promptidl;</prompt> <userinput><command>    , small &numb1; = [1, 2, 2], /noerase &numb2;</command></userinput> <ulink url="figpng/basic_splot3.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>    , small &numb1; = [1, 2, 2], /noerase &numb2;</command></userinput> <ulink url="figpng/basic_splot3.png?format=raw">&showfig;</ulink>
 	</screen>
 	  <calloutlist>
@@ -273,5 +273,5 @@
   <prompt>&promptidl;</prompt> <userinput><command>z = dist(n)</command></userinput>
   <computeroutput>% Compiled module: DIST.</computeroutput>
-  <prompt>&promptidl;</prompt> <userinput><command>scontour, z</command></userinput> <ulink url="figpng/basic_scontour1.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>scontour, z</command></userinput> <ulink url="figpng/basic_scontour1.png?format=raw">&showfig;</ulink>
   <computeroutput>% Compiled module: SCONTOUR.</computeroutput>
   <computeroutput>% Compiled module: CHKSTRU.</computeroutput>
@@ -283,5 +283,5 @@
 	<screen format="linespecific">
   <prompt>&promptidl;</prompt> <userinput><command>scontour, z, /fill, nlevels = 15, subtitle = 'nicer contour' $</command></userinput>
-  <prompt>&promptidl;</prompt> <userinput><command>    , xtitle = 'x index', charsize = 1.5</command></userinput> <ulink url="figpng/basic_scontour2.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>    , xtitle = 'x index', charsize = 1.5</command></userinput> <ulink url="figpng/basic_scontour2.png?format=raw">&showfig;</ulink>
 	</screen>
 It can be used in combinanson with contour to make more complex plots:
@@ -294,5 +294,5 @@
   <prompt>&promptidl;</prompt> <userinput><command>scontour, z, levels = n*ind, c_orientation = 180*ind, c_spacing = 0.4*ind</command></userinput>
   <prompt>&promptidl;</prompt> <userinput><command>contour, z, /overplot, c_label = rebin([1, 0], 2, n) &numb1;, levels = n*ind $</command></userinput>
-  <prompt>&promptidl;</prompt> <userinput><command>    , c_charthick = 2, c_charsize = 1.5, c_colors = 250*ind</command></userinput> <ulink url="figpng/basic_scontour3.png">&showfig;</ulink>
+  <prompt>&promptidl;</prompt> <userinput><command>    , c_charthick = 2, c_charsize = 1.5, c_colors = 250*ind</command></userinput> <ulink url="figpng/basic_scontour3.png?format=raw">&showfig;</ulink>
 	</screen>
 	<calloutlist>
@@ -310,7 +310,7 @@
 	</calloutlist>
 	</screenco>
-	<command>scontour</command> is compatible with the positioning method associated with the <computeroutput>small</computeroutput> keyword. See for example the test file <ulink url="../../Tests/tst_basic.pro"><filename>tst_basic.pro</filename></ulink>:
-	<screen format="linespecific">
-  <prompt>&promptidl;</prompt> <userinput><command>tst_basic</command></userinput> <ulink url="figpng/tst_basic.png">&showfig;</ulink>
+	<command>scontour</command> is compatible with the positioning method associated with the <computeroutput>small</computeroutput> keyword. See for example the test file <ulink url="../../Tests/tst_basic.pro?format=raw"><filename>tst_basic.pro</filename></ulink>:
+	<screen format="linespecific">
+  <prompt>&promptidl;</prompt> <userinput><command>tst_basic</command></userinput> <ulink url="figpng/tst_basic.png?format=raw">&showfig;</ulink>
 	</screen>
       </para>
@@ -324,5 +324,5 @@
 	  <command>tvplus</command> is a enhanced version of tvscl and allow you to have a quick look and perform basic exploration of 2D arrays.
 	  <screen format="linespecific">
-	    <prompt>&promptidl;</prompt> <userinput><command>tvplus, dist(20)</command></userinput> <ulink url="figpng/tvplus.png">&showfig;</ulink>
+	    <prompt>&promptidl;</prompt> <userinput><command>tvplus, dist(20)</command></userinput> <ulink url="figpng/tvplus.png?format=raw">&showfig;</ulink>
   <computeroutput>left button  : mouse position and associated array value</computeroutput>
   <computeroutput>middle button: use it twice to define a zoom box</computeroutput>
@@ -377,5 +377,5 @@
   <computeroutput>% Compiled module: DEFINETRI.</computeroutput>
 	  </screen>
-	  This <ulink url="../../Tests/tst_initlev.pro"><command>@tst_initlev</command></ulink> command allows us to define:
+	  This <ulink url="../../Tests/tst_initlev.pro?format=raw"><command>@tst_initlev</command></ulink> command allows us to define:
 	  <itemizedlist>
 	    <listitem><simpara>domain dimensions, stored in <varname>jpi, jpj and jpk</varname></simpara></listitem>
@@ -419,15 +419,15 @@
 	  We provide other initialization methods/examples
 	  <itemizedlist>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_short.pro">@tst_initorca2_short</ulink> : ORCA2 example</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_short.pro">@tst_initorca05_short</ulink> : ORCA05 example</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initlev_stride.pro">@tst_initlev_stride</ulink> : same as @tst_initlev but we skip on point over 2 in x and y direction</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_short_stride.pro">@tst_initorca2_short_stride</ulink> : ORCA2 with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_short_stride.pro">@tst_initorca05_short_stride</ulink> : ORCA05 with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initlev_index.pro">@tst_initlev_index</ulink> : in that case we load the grid using points index as axis instead of the longitude/latitude position</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index.pro">@tst_initorca2_index</ulink> : load ORCA2 as it see by the model</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index.pro">@tst_initorca05_index</ulink> : load ORCA05 as it see by the model</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initlev_index_stride.pro">@tst_initlev_index_stride</ulink> : @tst_initlev_index with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index_stride.pro">@tst_initorca2_index_stride</ulink> : ORCA2 in index with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index_stride.pro">@tst_initorca05_index_stride</ulink> : ORCA05 in index with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_short.pro?format=raw">@tst_initorca2_short</ulink> : ORCA2 example</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_short.pro?format=raw">@tst_initorca05_short</ulink> : ORCA05 example</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initlev_stride.pro?format=raw">@tst_initlev_stride</ulink> : same as @tst_initlev but we skip on point over 2 in x and y direction</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_short_stride.pro?format=raw">@tst_initorca2_short_stride</ulink> : ORCA2 with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_short_stride.pro?format=raw">@tst_initorca05_short_stride</ulink> : ORCA05 with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initlev_index.pro?format=raw">@tst_initlev_index</ulink> : in that case we load the grid using points index as axis instead of the longitude/latitude position</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index.pro?format=raw">@tst_initorca2_index</ulink> : load ORCA2 as it see by the model</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index.pro?format=raw">@tst_initorca05_index</ulink> : load ORCA05 as it see by the model</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initlev_index_stride.pro?format=raw">@tst_initlev_index_stride</ulink> : @tst_initlev_index with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index_stride.pro?format=raw">@tst_initorca2_index_stride</ulink> : ORCA2 in index with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index_stride.pro?format=raw">@tst_initorca05_index_stride</ulink> : ORCA05 in index with stride</simpara></listitem>
 	  </itemizedlist>
 	</para>
@@ -440,12 +440,12 @@
 	  When the grid is really irregular (its abscissa and ordinate cannot be descried by a vector), loading the grid directly from the data forces us to make an approximation when computing the grid corners position and the cells size. In that case, it can be preferable to load the grid from the meshmask file created by OPA. As OPA use a Arakawa-C discretization, loading the grid from the meshmask will also define all parameters related to the U, V and F grids (glam[uv],gphi[uv], e[12][uvf]). Note that, when using a simple <link linkend="load_fromdata">grid definition from the data itself</link> (with <filename>initncdf</filename> or <filename>computegrid</filename>), adding the keyword /FULLCGRID leads also to the definition of all U, V and F grids parameters. There is the examples to load ORCA grids from OPA meshmask.
 	  <itemizedlist>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2.pro">@tst_initorca2</ulink> : ORCA2</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05.pro">@tst_initorca05</ulink> : ORCA05</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_stride.pro">@tst_initorca2_stride</ulink> : ORCA2 with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_stride.pro">@tst_initorca05_stride</ulink> : ORCA05 with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index.pro">@tst_initorca2_index</ulink> : load ORCA2 as it see by the model</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index.pro">@tst_initorca05_index</ulink> : load ORCA05 as it see by the model</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index_stride.pro">@tst_initorca2_index_stride</ulink> : ORCA2 in index with stride</simpara></listitem>
-	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index_stride.pro">@tst_initorca05_index_stride</ulink> : ORCA05 in index with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2.pro?format=raw">@tst_initorca2</ulink> : ORCA2</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05.pro?format=raw">@tst_initorca05</ulink> : ORCA05</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_stride.pro?format=raw">@tst_initorca2_stride</ulink> : ORCA2 with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_stride.pro?format=raw">@tst_initorca05_stride</ulink> : ORCA05 with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index.pro?format=raw">@tst_initorca2_index</ulink> : load ORCA2 as it see by the model</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index.pro?format=raw">@tst_initorca05_index</ulink> : load ORCA05 as it see by the model</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca2_index_stride.pro?format=raw">@tst_initorca2_index_stride</ulink> : ORCA2 in index with stride</simpara></listitem>
+	    <listitem><simpara><ulink url="../../Tests/tst_initorca05_index_stride.pro?format=raw">@tst_initorca05_index_stride</ulink> : ORCA05 in index with stride</simpara></listitem>
 	  </itemizedlist>
 	</para>
@@ -458,5 +458,5 @@
       </title>
 	<para>
-	  A quick presentation of horizontal plots and maps is shown in <ulink url="../../Tests/tst_plt.pro">tst_plt</ulink>. After laoding any of the grid (for example with one of the <link linkend="load_grid">above examples</link>). Just try:
+	  A quick presentation of horizontal plots and maps is shown in <ulink url="../../Tests/tst_plt.pro?format=raw">tst_plt</ulink>. After laoding any of the grid (for example with one of the <link linkend="load_grid">above examples</link>). Just try:
 	  <screen format="linespecific">
   <prompt>&promptidl;</prompt> <userinput><command>tst_plt</command></userinput>
@@ -482,5 +482,5 @@
       </title>
 	<para>
-	  A quick presentation of vertical sections is shown in <ulink url="../../Tests/tst_pltz.pro">tst_pltz</ulink>. After laoding any of the grid (for example with one of the <link linkend="load_grid">above examples</link>). Just try:
+	  A quick presentation of vertical sections is shown in <ulink url="../../Tests/tst_pltz.pro?format=raw">tst_pltz</ulink>. After laoding any of the grid (for example with one of the <link linkend="load_grid">above examples</link>). Just try:
 	  <screen format="linespecific">
   <prompt>&promptidl;</prompt> <userinput><command>tst_pltz</command></userinput>
@@ -506,5 +506,5 @@
       </title>
 	<para>
-	  A quick presentation of hovmoellers and time series is shown in <ulink url="../../Tests/tst_pltt.pro">tst_pltt</ulink>. After laoding any of the grid (for example with one of the <link linkend="load_grid">above examples</link>). Just try:
+	  A quick presentation of hovmoellers and time series is shown in <ulink url="../../Tests/tst_pltt.pro?format=raw">tst_pltt</ulink>. After laoding any of the grid (for example with one of the <link linkend="load_grid">above examples</link>). Just try:
 	  <screen format="linespecific">
   <prompt>&promptidl;</prompt> <userinput><command>tst_pltt</command></userinput>